Index: q931.c
===================================================================
--- q931.c	(revision 406)
+++ q931.c	(working copy)
@@ -3343,6 +3343,25 @@
 		}
 		pri->ev.e = PRI_EVENT_PROGRESS;
 		pri->ev.proceeding.cause = c->cause;
+
+	        if ((ie->data[1] & 0x7f) == Q931_PROG_CALLED_NOT_ISDN)
+		{
+			if (c->newcall) {
+				q931_release_complete(pri,c,PRI_CAUSE_INVALID_CALL_REFERENCE);
+				break;
+			}
+			c->ourcallstate = Q931_CALL_STATE_CALL_DELIVERED;
+			c->peercallstate = Q931_CALL_STATE_CALL_RECEIVED;
+			pri->ev.e = PRI_EVENT_RINGING;
+			pri->ev.ringing.channel = c->channelno | (c->ds1no << 8) | (c->ds1explicit << 16);
+			pri->ev.ringing.cref = c->cr;
+			pri->ev.ringing.call = c;
+			pri->ev.ringing.progress = c->progress;
+			pri->ev.ringing.progressmask = c->progressmask;
+			libpri_copy_string(pri->ev.ringing.useruserinfo, c->useruserinfo, sizeof(pri->ev.ringing.useruserinfo));
+			c->useruserinfo[0] = '\0';
+		}
+
 		/* Fall through */
 	case Q931_CALL_PROCEEDING:
 		if (c->newcall) {
